# This file was auto-generated by Fern from our API Definition.

import enum
import typing

T_Result = typing.TypeVar("T_Result")


class AppSchemaResponsesMessageRole(str, enum.Enum):
    """
    Enum representing the role of a message in a conversation.

    - system: The system message that sets the context or instructions.
    - user: The user's message in the conversation.
    - assistant: The AI assistant's response in the conversation.
    """

    SYSTEM = "system"
    USER = "user"
    ASSISTANT = "assistant"

    def visit(
        self,
        system: typing.Callable[[], T_Result],
        user: typing.Callable[[], T_Result],
        assistant: typing.Callable[[], T_Result],
    ) -> T_Result:
        if self is AppSchemaResponsesMessageRole.SYSTEM:
            return system()
        if self is AppSchemaResponsesMessageRole.USER:
            return user()
        if self is AppSchemaResponsesMessageRole.ASSISTANT:
            return assistant()
